//+------------------------------------------------------------------+
//|                                              UniTrendDefines.mqh |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"

enum EType{
   Type_ADX_PDIMDI,
   Type_ADX_Level,
   Type_ADXW_PDIMDI,
   Type_ADXW_Level,
   Type_Alligator,
   Type_AMA_Dir,
   Type_AMA_2MA,
   Type_ATR_Level,
   Type_BuBe_Level,
   Type_BuBe_Dir,
   Type_Bands,
   Type_CCI_Level,
   Type_Chaikin_Level,
   Type_DEMA_Dir,
   Type_DEMA_2MA,
   Type_DeMarker_Level,
   Type_Envelopes,
   Type_Force_Level,
   Type_Fractals,
   Type_FrAMA_Dir,
   Type_FrAMA_2MA,
   Type_Ichimoku_TK,
   Type_Ichimoku_SASB,
   Type_Momentum_Level,
   Type_MFI_Level,
   Type_MA_Dir,
   Type_MA_2MA,
   Type_OsMA_Dir,
   Type_OsMA_Level,
   Type_MACD_Dir,
   Type_MACD_Level,
   Type_SAR,
   Type_RSI_Level,
   Type_RVI_Level,
   Type_RVI_MS,
   Type_STD_Level,
   Type_Sto_Dir,
   Type_Sto_Level,
   Type_Sto_MS,
   Type_TEMA_Dir,
   Type_TEMA_2MA,
   Type_TriX_Dir,
   Type_TriX_2MA,
   Type_VIDyA_Dir,
   Type_VIDyA_2MA,   
   Type_Volumes
};

EType Types[]={
   Type_ADX_PDIMDI, //1
   Type_ADX_Level,
   Type_ADXW_PDIMDI,
   Type_ADXW_Level,
   Type_Alligator,
   Type_AMA_Dir,
   Type_AMA_2MA,
   Type_ATR_Level,
   Type_BuBe_Level,
   Type_BuBe_Dir, //10
   Type_Bands,
   Type_CCI_Level,
   Type_Chaikin_Level,
   Type_DEMA_Dir,
   Type_DEMA_2MA,
   Type_DeMarker_Level,
   Type_Envelopes,
   Type_Force_Level,
   Type_Fractals,
   Type_FrAMA_Dir, //20
   Type_FrAMA_2MA,
   Type_Ichimoku_TK,
   Type_Ichimoku_SASB,
   Type_Momentum_Level,
   Type_MFI_Level,
   Type_MA_Dir,
   Type_MA_2MA,
   Type_OsMA_Dir,
   Type_OsMA_Level,
   Type_MACD_Dir, //30
   Type_MACD_Level,
   Type_SAR,
   Type_RSI_Level,
   Type_RVI_Level,
   Type_RVI_MS,
   Type_STD_Level,
   Type_Sto_Dir,
   Type_Sto_Level,
   Type_Sto_MS,
   Type_TEMA_Dir, //40
   Type_TEMA_2MA,
   Type_TriX_Dir,
   Type_TriX_2MA,
   Type_VIDyA_Dir,
   Type_VIDyA_2MA, //45   
   Type_Volumes
};

struct SExtParams{
   int                  f_period1;
   int 	               f_shift1;
   int 	               f_period2;
   int 	               f_shift2;
   int 	               f_period3;
   int 	               f_shift3;
   long 	               f_method;
   long 	               f_price;
   long                 f_volume;
   long 	               f_sto_price;
   double 	            f_level;
   int 	               f_dot2shift;
   double 	            f_step;   
   double 	            f_maximum;   
   int 	               s_period1;
   int 	               s_shift1;
   int 	               s_period2;
   int 	               s_shift2;
   int 	               s_period3;
   int                  s_shift3;
   long 	               s_method;
   long 	               s_price; 
   int                  mult;
   int                  level_digits;
   int                  sar_step_digits;
   int                  sar_maximum_digits;       
};

#define ADX_LEVEL_DIGITS         0
#define ADXW_LEVEL_DIGITS        0
#define ATR_LEVEL_DIGITS         1 // *Point
#define BUBE_LEVELS_DIGITS       1 // *Point
#define CCI_LEVEL_DIGITS         0
#define CHAIKIN_LEVEL_DIGITS     0
#define DEMARKER_LEVEL_DIGITS    2
#define FORCE_LEVEL_DIGITS       3
#define MOMENTUM_LEVEL_DIGITS    2
#define MFI_LEVEL_DIGITS         0
#define OSMA_LEVBEL_DIGITS       2 // *Point
#define MACD_LEVEL_DIGITS        2 // *Point
#define RSI_LEVEL_DIGITS         0
#define RVI_LEVEL_DIGITS         2
#define STD_LEVEL_DIGITS         1 // *Point
#define STO_LEVEL_DIGITS         0
#define BANDS_LEVEL_DIGITS       1
#define ENVELOPES_LEVEL_DIGITS   2
#define SAR_STEP_DIGITS          3
#define SAR_MAXIMUM_DIGITS       2

enum EAlerts{
   Alerts_off=0,
   Alerts_Bar0=1,
   Alerts_Bar1=2
};

EAlerts e_alerts[]={Alerts_off,Alerts_Bar0,Alerts_Bar1};

ENUM_APPLIED_PRICE e_price[]={   PRICE_CLOSE,
                                 PRICE_OPEN,
                                 PRICE_HIGH,
                                 PRICE_LOW,
                                 PRICE_MEDIAN,
                                 PRICE_TYPICAL,
                                 PRICE_WEIGHTED
};

ENUM_MA_METHOD e_method[]={MODE_SMA,MODE_EMA,MODE_SMMA,MODE_LWMA};

ENUM_APPLIED_VOLUME e_volume[]={VOLUME_TICK,VOLUME_REAL};

ENUM_STO_PRICE e_sto_price[]={STO_LOWHIGH,STO_CLOSECLOSE};

#define FORM_WIDTH 210
#define SPIN_BOX_WIDTH 110
#define COMBO_BOX_WIDTH 110

#define PARAMETER_EMPTY INT_MAX